{
  CMF Player - (c) vIRtECH 1996-1997 Ansgar Scherp

  Version 3.1a - some major and minor bugfixes and some asm speed - up.

  PLAYING CMF-FILES WITHOUT USING THE SBFMDRV FROM CREATIVE LABS (R).
      FOR PROTECTED MODE and REAL MODE including FULL SOURCE CODE!

  (c) vIRTUAL tECHNOLOGIES 1996

  Based on the source by :
    Carl Eric Codere ( codc01@gel.usherb.ca )
    http://www-edu.gel.usherb.ca/codc01

  Special thanks to you.

  Distribition via any media is explicit allowed.

  DISCLAIMER:

  We give no warranty for this code, because it was firstly coded for us,
  and not for the public.
  But after lot of people asking us for releasing the source, we decided,
  to make it now available.
  But however, I really don't think that there is a bug in this unit.

  You're not allowed to re-release the source in a modified version of it.
  However, you can use it as it is for any (even commercial) projects, but
  you have to give credits to the authors.

  for more information contact us:

    Ansgar Scherp
    scherp.ansgar@informatik.uni-oldenburg.de

    http://www.informatik.uni-oldenburg.de/~virtech/

    Mailbox : + 49 (0) 4441 / 851887
    Hotline : + 49 (0) 4441 / 851717 (english, german)

  Please report, if you find any bugs in this source code.

}

{$S-}
unit _ADLIB;

interface

uses Dos;

{ *** all defined constants ...
      do we already know in this form :-) ***}

const
  Modulator      =  0;
  Carrier        =  1;
  { Percussive voice numbers }
  BassDrumVoice  =  6;         { Bass Drum Voice number   }
  SnareDrumVoice =  7;         { Snare Drum Voice number  }
  TomTomVoice    =  8;         { Tom-Tom Voice Number     }
  CymbalVoice    =  9;         { Cymbal Voice number      }
  HihatVoice     = 10;         { Hihat Voice number       }

  { Standard MIDI MID_C }
  MidiMiddleC = 60;
  CardMiddleC = 48;

Const
  { *** compare this note-tab to own one!!! *** }
  NoteTab : array[ 0 .. 126 ] of byte = (
    $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,
    $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,
    $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,
    $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,
    $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,
    $40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,
    $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B,
    $60,$61,$62,$63,$64,$65,$66,$67,$69,$6A,$6B,
    $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B,
    $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B,
    $7B,$7B,$7B,$7B,$7B,$7B,$7B,$7B );

  FreqTable : array[ 0 .. 767 ] of byte = (
    $57,$01,$58,$01,$58,$01,$59,$01,$59,$01,$5a,$01,$5b,$01,$5b,$01,
    $5c,$01,$5d,$01,$5d,$01,$5e,$01,$5e,$01,$5f,$01,$60,$01,$60,$01,
    $61,$01,$62,$01,$62,$01,$63,$01,$64,$01,$64,$01,$65,$01,$65,$01,
    $66,$01,$67,$01,$67,$01,$68,$01,$69,$01,$69,$01,$6a,$01,$6b,$01,
    $6b,$01,$6c,$01,$6d,$01,$6d,$01,$6e,$01,$6f,$01,$6f,$01,$70,$01,
    $71,$01,$71,$01,$72,$01,$73,$01,$73,$01,$74,$01,$75,$01,$75,$01,
    $76,$01,$77,$01,$77,$01,$78,$01,$79,$01,$79,$01,$7a,$01,$7b,$01,
    $7b,$01,$7c,$01,$7d,$01,$7d,$01,$7e,$01,$7f,$01,$80,$01,$80,$01,
    $81,$01,$82,$01,$82,$01,$83,$01,$84,$01,$84,$01,$85,$01,$86,$01,
    $87,$01,$87,$01,$88,$01,$89,$01,$89,$01,$8a,$01,$8b,$01,$8b,$01,
    $8c,$01,$8d,$01,$8e,$01,$8e,$01,$8f,$01,$90,$01,$91,$01,$91,$01,
    $92,$01,$93,$01,$93,$01,$94,$01,$95,$01,$96,$01,$96,$01,$97,$01,
    $98,$01,$99,$01,$99,$01,$9a,$01,$9b,$01,$9c,$01,$9c,$01,$9d,$01,
    $9e,$01,$9e,$01,$9f,$01,$a0,$01,$a1,$01,$a1,$01,$a2,$01,$a3,$01,
    $a4,$01,$a5,$01,$a5,$01,$a6,$01,$a7,$01,$a8,$01,$a8,$01,$a9,$01,
    $aa,$01,$ab,$01,$ab,$01,$ac,$01,$ad,$01,$ae,$01,$ae,$01,$af,$01,
    $b0,$01,$b1,$01,$b2,$01,$b2,$01,$b3,$01,$b4,$01,$b5,$01,$b6,$01,
    $b6,$01,$b7,$01,$b8,$01,$b9,$01,$ba,$01,$ba,$01,$bb,$01,$bc,$01,
    $bd,$01,$be,$01,$be,$01,$bf,$01,$c0,$01,$c1,$01,$c2,$01,$c2,$01,
    $c3,$01,$c4,$01,$c5,$01,$c6,$01,$c6,$01,$c7,$01,$c8,$01,$c9,$01,
    $ca,$01,$cb,$01,$cb,$01,$cc,$01,$cd,$01,$ce,$01,$cf,$01,$d0,$01,
    $d0,$01,$d1,$01,$d2,$01,$d3,$01,$d4,$01,$d5,$01,$d5,$01,$d6,$01,
    $d7,$01,$d8,$01,$d9,$01,$da,$01,$db,$01,$db,$01,$dc,$01,$dd,$01,
    $de,$01,$df,$01,$e0,$01,$e1,$01,$e1,$01,$e2,$01,$e3,$01,$e4,$01,
    $e5,$01,$e6,$01,$e7,$01,$e8,$01,$e8,$01,$e9,$01,$ea,$01,$eb,$01,
    $ec,$01,$ed,$01,$ee,$01,$ef,$01,$f0,$01,$f0,$01,$f1,$01,$f2,$01,
    $f3,$01,$f4,$01,$f5,$01,$f6,$01,$f7,$01,$f8,$01,$f9,$01,$fa,$01,
    $fa,$01,$fb,$01,$fc,$01,$fd,$01,$fe,$01,$ff,$01,$00,$02,$01,$02,
    $02,$02,$03,$02,$04,$02,$05,$02,$06,$02,$06,$02,$07,$02,$08,$02,
    $09,$02,$0a,$02,$0b,$02,$0c,$02,$0d,$02,$0e,$02,$0f,$02,$10,$02,
    $11,$02,$12,$02,$13,$02,$14,$02,$15,$02,$16,$02,$17,$02,$18,$02,
    $19,$02,$1a,$02,$1a,$02,$1b,$02,$1c,$02,$1d,$02,$1e,$02,$1f,$02,
    $20,$02,$21,$02,$22,$02,$23,$02,$24,$02,$25,$02,$26,$02,$27,$02,
    $28,$02,$29,$02,$2a,$02,$2b,$02,$2c,$02,$2d,$02,$2e,$02,$2f,$02,
    $30,$02,$31,$02,$32,$02,$33,$02,$34,$02,$35,$02,$36,$02,$37,$02,
    $38,$02,$39,$02,$3b,$02,$3c,$02,$3d,$02,$3e,$02,$3f,$02,$40,$02,
    $41,$02,$42,$02,$43,$02,$44,$02,$45,$02,$46,$02,$47,$02,$48,$02,
    $49,$02,$4a,$02,$4b,$02,$4c,$02,$4d,$02,$4e,$02,$4f,$02,$51,$02,
    $52,$02,$53,$02,$54,$02,$55,$02,$56,$02,$57,$02,$58,$02,$59,$02,
    $5a,$02,$5b,$02,$5c,$02,$5e,$02,$5f,$02,$60,$02,$61,$02,$62,$02,
    $63,$02,$64,$02,$65,$02,$66,$02,$67,$02,$69,$02,$6a,$02,$6b,$02,
    $6c,$02,$6d,$02,$6e,$02,$6f,$02,$70,$02,$72,$02,$73,$02,$74,$02,
    $75,$02,$76,$02,$77,$02,$78,$02,$79,$02,$7b,$02,$7c,$02,$7d,$02,
    $7e,$02,$7f,$02,$80,$02,$82,$02,$83,$02,$84,$02,$85,$02,$86,$02,
    $87,$02,$89,$02,$8a,$02,$8b,$02,$8c,$02,$8d,$02,$8e,$02,$90,$02,
    $91,$02,$92,$02,$93,$02,$94,$02,$96,$02,$97,$02,$98,$02,$99,$02,
    $9a,$02,$9c,$02,$9d,$02,$9e,$02,$9f,$02,$a0,$02,$a2,$02,$a3,$02,
    $a4,$02,$a5,$02,$a6,$02,$a8,$02,$a9,$02,$aa,$02,$ab,$02,$ad,$02 );

  { Offset of modulator for each voice }
  TableModulator : array[0..13] of byte =
    ( $00,$01,$02,$08,$09,$0A,$10,$11,$12,$01,$11,$4F,$00,$F1 );

  { Offset of operator for percussive mode     }
  { Offset memory boundary cross in asm Source }
  TablePModulator : array[0..10] of Byte =
    ( $f2,$53,$74,$00,$00,$08,$10,$14,$12,$15,$11 );

  { Offset of Modulator in each voice }
  SlotMVoice : array[0..8,0..1] of Byte =
    ( ($00, $03), ($01, $04), ($02, $05), ($08, $0B), ($09, $0C),
      ($0a, $0D), ($10, $13), ($11, $14), ($12, $15) );

  { Percussion Rhythm Enable bits }
  PercBits : array[0..4] of Byte =
    ( $10,$08,$04,$02,$01);

  { Offset voice when in percussive voice. }
  PercussiveOffset : array[0..10] of Byte =
    ( $11,$10,$08,$04,$02,$01,$06,$07,$08,$08,$07);


type
  TBit = 0..1;

var
  { controls, if AdLibCard had been found or not }
  AdlibCardFound : boolean;

  { This determines if both operators produce sound directly; if so, then
    modyfing the volume must be done with both operators
    TRUE = Both Modulator and Carrier must be changed to change
    the volume. (TRUE = FM MODE, FALSE = AM MODE )                        }
  Algorithm  : Array[0..15] of boolean;

  Percussive : boolean; { Percussion Mode parameter }
  MaxVoices  : integer; { maximum number of available voices }

  NotePlaying           : Array[ 0 .. 15 ] of boolean; { TRUE if a note playing on that voice }
  MaxVolume             : Array[ 0 .. 15 ] of byte;    { Maximum volume for that voice READ ONLY!}
  ModulatorScalingLevel : Array[ 0 .. 15 ] of byte;
  CarrierScalingLevel   : Array[ 0 .. 15 ] of byte;
  Output                : Array[ 0 .. 15 ] of word;    { Direct A0B0 Register outputs }
  SemiToneCurrent       : Array[ 0 .. 15 ] of integer; { Current semi tones modify    }
  CurrentPlayingNote    : Array[ 0 .. 15 ] of byte;

  BDRegister: Byte; { Current Value in BDRegister  }

  { Initialise sound card in melodic mode with pianos }
  procedure AdLibInit;
  { Put all adlib registers back to zero              }
  procedure AdLibDone;
  { Silence a voice with the specified note           }
  procedure NoteOff(Voice:Byte; Note:Byte);
  { Play a voice with the specified note              }
  procedure NoteOn(Voice: Byte; Note: Byte);
  { Change the volume of a voice (0 (lowest) < Volume < 127 }
  procedure SetVolume(Voice: Byte; AVolume: Byte);
  { Modify the notes by 1-127 semi-tones                    }
  procedure SemiToneup(Voice: Byte; Value: Shortint);
  { Modify the notes by 1-127 semi-tones                    }
  procedure SemiToneDown(Voice: Byte; Value: Shortint);

  { Selects either Melodic or Percussive mode
    TRUE = Percussive Mode                    }
  procedure SetPercussive(Mode: Boolean);

  { Writes to Registers 20h-35h
    AMP. MODULATION / VIBRATO / EG TYPE / MODULATION
    MULTIPLIER
    SetWaveChar -> Writes Values directly to Register }
  procedure SetWaveChar(Voice: Byte; ModCar: TBit; Value: Byte);

  { Writes to Register 40h-55h
    SCALING LEVEL  / OUTPUT LEVEL
    AllScalingOutput -> Writes Byte directly to register     }
  procedure AllScalingOutput(Voice: Byte; ModCar: TBit; Value: Byte);

  { Writes to Registers 60h-75h
      ATTACK RATE / DECAY RATE
      AllAttackDecay -> Writes Value directly to Register  }
  procedure AllAttackDecay(Voice: Byte; ModCar: TBit; Value: Byte);

  { Writes to Registers 80h-95h
    SUSTAIN RATE/ RELEASE RATE
    AllSusRelease -> Outputs Byte directly to Register    }
  procedure AllSusRelease(Voice: Byte; ModCar: TBit; Value: Byte);

  { Writes To Register BDh
    AMPLITUDE MODULATION DEPTH / VIBRATO DEPTH / RHYTHM

    SetAM  -> Toggles the AM Depth On/Off Only
    SetVib -> Toggles the Vibrato Depth On/Off Only }
  procedure SetAM(AM: Boolean);
  procedure SetVibrato(Vib: Boolean);

  { Writes To Registers C0h-C8h
    AllFeedBack -> Outputs Byte directly to Register }
  procedure AllFeedback(Voice: Byte; Value: Byte);

  { Writes To Port E0h-F5h -> Selects Waveform to use
    WAVEFORM SELECT
           Only value in this register                             }
  procedure SetWaveSelect(Voice:Byte;ModCar: TBit; Value: Byte);

  { Calculates the note to play }
  Function CalcNote(Voice:byte; Note: Byte): Word;
  { Sets the default rhythm instruments }
  procedure SetRhythmInstruments;
  { Sets up the default melodic instruments for all voices }
  procedure SetMelodicInstruments;

  { Check if an Adlib Board is installed }
  Function BoardInstalled: Boolean;
  procedure WriteAdlibPort(reg: Byte; Value: Byte);

implementation

{ Percussive voices instruments }
Type
  TInstrument =
    Record
      WaveChar       : Byte; { Wave Characteristic         }
      ScalingOutput  : Byte; { Scaling Level / Ouput level }
      AttackDecay    : Byte; { Attack / Decay Rate         }
      SustainRelease : Byte; { Sustain / Release Rate      }
      Feedback       : Byte; { Feedback                    }
      SetWaveSelect  : Byte; { Type of Wave to use         }
    end;

Const
  { Klavier }
  ElectricPiano : array[0..1] of TInstrument = (
    ( WaveChar       :  65; ScalingOutput : 127; AttackDecay   : 242;
      SustainRelease :  81; FeedBack      :   7; SetWaveSelect :   1 ),
    ( WaveChar       :  19; ScalingOutput :   0; AttackDecay   : 242;
      SustainRelease : 241; FeedBack      :   0; SetWaveSelect : 0 ) );

  { PERCUSSIVE MODE VOICES }
  BassDrum:array[0..1] of TInstrument = (
    ( WaveChar       :   0; ScalingOutput :  11; AttackDecay   : 168;
      SustainRelease :  76; FeedBack      :   1; SetWaveSelect :   1 ),
    ( WaveChar       :   0; ScalingOutput :   0; AttackDecay   : 214;
      SustainRelease :  79; FeedBack      :   1; SetWaveSelect : 0 ) );

  SnareDrum: TInstrument =
    ( WaveChar       :  12; ScalingOutput :   0; AttackDecay   : 248;
      SustainRelease : 181; FeedBack      :   0; SetWaveSelect :   0 );

  TomTom: TInstrument =
    ( WaveChar       :   4; ScalingOutput :   0; AttackDecay   : 247;
      SustainRelease : 181; FeedBack      :   0; SetWaveSelect :   0 );

  Cymbal: TInstrument =
    ( WaveChar       :   1; ScalingOutput :   0; AttackDecay    : 245;
      SustainRelease : 181; FeedBack      :   0; SetWaveSelect  :   0 );

  HiHat: TInstrument =
    ( WaveChar       : 1;   ScalingOutput :   0; AttackDecay    : 247;
      SustainRelease : 181; FeedBack      :   0; SetWaveSelect  :   0 );


{ Returns TRUE if an adlib card was detected }
{ otherwise returns false.                   }
function BoardInstalled:Boolean;

var
  StatusReg1,
  StatusReg2  : Integer;

  Hour,
  Minute,
  Second,
  Sec100      : word;

  Time1,
  Time2       : longint;

begin
  BoardInstalled := False;

  WriteAdlibPort($04,$60);      { Reset both timers       }
  WriteAdlibPort($04,$80);      { Enable Timer interrupts }

  StatusReg1:=Port[$388];       { Read Status Register    }

  WriteAdlibPort($02,$FF);
  WriteAdlibPort($04,$21);      { Start Timer 21h         }

{  Delay(500);              { Wait 80 ms              }

  GetTime( Hour, Minute, Second, Sec100 );
  Time1 := Sec100 + Second*100 +
           longint(Minute)*60*100 + longint(Hour)*24*60*100;
  Time2 := Time1;
  while Time2 < Time1 + 10 {wait for 10ms } do
    begin
      GetTime( Hour, Minute, Second, Sec100 );
      Time2 := Sec100 + Second*100 +
               longint(Minute)*60*100 + longint(Hour)*24*60*100;
    end;

  StatusReg2:=Port[$388];       { Read Status Register    }

  WriteAdlibPort($04,$60);      { Reset both timers       }
  WriteAdlibPort($04,$80);      { Enable timer interrupts }

  StatusReg1:= StatusReg1 and $E0;
  StatusReg2:= StatusReg2 and $E0;

  If ( StatusReg1 = $00) and ( StatusReg2 = $C0) then BoardInstalled:=True;
end;

{ procedure WriteAdlibPort(reg: Integer; Value: Byte);
   Writes to a specified Adlib register.
   reg -> register number to write to
   value -> value to write to register             }
procedure WriteAdlibPort(reg: Byte; Value: Byte); assembler;
asm
  mov  dx, 228h                  { Adlib index port }
  mov  al, [Reg]

  out  dx,al                     { Set the index }

  { Wait For hardware to respond }
  in al, dx;{ in al, dx; in al, dx
  in al, dx; in al, dx; in al, dx}
  inc  dx                        { Adlib register port }
  mov  al, [Value]
  out  dx, al                    { Set the register value }

  dec  dx                        { Adlib index port }
  { Wait For hardware to respond // even on my P100 with sb 16 not necessary }
{  in al, dx; in al, dx; in al, dx; in al, dx; in al, dx
    in al, dx; in al, dx; in al, dx; in al, dx; in al, dx
    in al, dx; in al, dx; in al, dx; in al, dx; in al, dx
    in al, dx; in al, dx; in al, dx; in al, dx; in al, dx
    in al, dx; in al, dx; in al, dx; in al, dx; in al, dx
    in al, dx; in al, dx; in al, dx; in al, dx; in al, dx
    in al, dx; in al, dx; in al, dx; in al, dx; in al, dx{}
end;


procedure AdLibInit;
var
  i : Byte;

begin
  { If an Adlib compatible sound card is NOT installed }
  AdlibCardFound := TRUE;
  If Not BoardInstalled then
    begin
      AdLibCardFound := false;
      exit;
    end;
  { Reset the Sound Card }
  FOR i := $01 TO $F5 do
     WriteAdlibPort(i, $00);

  WriteAdlibPort($01, $20);
  WriteAdlibPort($08, $40);
  { Also sets the correct instruments }
  SetPercussive(False);
end;


{ *** Start a note playing.                        ***

   0 <= voice <= 8 in melodic mode,
   0 <= voice <= 10 in percussive mode;
   0 <= pitch <= 127, 60 == MID_C ( the card can play between 12 and 107 }

procedure NoteOn(Voice: Byte; Note: Byte);
begin
 { Do a note off if note is already playing }
{ If NotePlaying[Voice] then
   begin}
 { DO ALWAYS A NOTE OF ??? }
     WriteAdlibPort($A0 + Voice, Lo(Output[Voice]));
     WriteAdlibPort($B0 + Voice, Hi(Output[Voice]));
{   end;}

 If Note > 107 then Note := 107;
 If Note < 12  then Note := 12;
 CurrentPlayingNote[ Voice ] := Note;

 { Melodic voice }
 If ( (Percussive) and (Voice < BassDrumVoice) ) OR (NOT Percussive) then
   begin
     Output[ Voice ] := CalcNote( Voice, Note );
     WriteAdlibPort( $A0 + Voice, Lo( Output[ Voice ] ) );
     { Enable key on by adding bitwise bit 5 }
     WriteAdlibPort( $B0 + Voice, Hi( Output[ Voice ] ) OR $20 );
     NotePlaying[ Voice ] := TRUE;
   end
 else
   begin
   { Percussive Voice }
     BDRegister := BDRegister OR PercBits[Voice-6];
     Output[Voice] := CalcNote(Voice, Note);
     NotePlaying[Voice] := TRUE;
     WriteAdlibPort($A0 + PercussiveOffset[Voice], Lo(Output[Voice]));
     WriteAdlibPort($B0 + PercussiveOffset[Voice], Hi(Output[Voice]));

     { Enable Key on in Rhythm Node }
     WriteAdlibPort($BD, BDRegister);
   end;
end;



procedure NoteOff(Voice:Byte; Note:Byte);
begin
  If NOT (NotePlaying[Voice]) then Exit;
  { Melodic Voice }
  If ((Percussive) and (Voice < BassDrumVoice)) OR (NOT Percussive) then
    begin
      NotePlaying[Voice] := FALSE;
      { We just need to rewrite to $B0 register }
      WriteAdlibPort($B0 + Voice, Hi(Output[Voice]));
    end
  else
    { Percussive Voice }
    begin
      BDRegister := BDRegister AND (NOT Percbits[Voice - 6]);
      NotePlaying[Voice] := FALSE;
      { Disable thee key-on for that percussive voice }
      WriteAdlibPort($BD, BDRegister);
    end;
end;


{ Put the chip in melodic mode (mode == 0), or in percussive mode
  (mode <> 0). If the melodic mode is chosen, all voices are set to
  electric-piano, else the first 5 are set to electric-piano, and the
  percussion voices to their default timbres.                         }
procedure SetPercussive(Mode: Boolean);
begin
  If NOT Mode then
    begin
      MaxVoices := $08;
      BdRegister := $C0;
      WriteAdlibPort($Bd, BDRegister);
      Percussive := FALSE;
   {   SetMelodicInstruments;}
    end
  else
    begin
      MaxVoices := $05;
      BDRegister := $E0;
      WriteAdlibPort($Bd, BDRegister);
      Percussive := TRUE;
      SetRhythmInstruments;
    end;
end;


procedure SetRhythmInstruments;
{ THIS THING TO OPTIMIZE FOR SIZE }
begin
 { BASS-DRUM Voice has two operators }
 CarrierScalingLevel[BassDrumVoice] :=
   BassDrum[Carrier].ScalingOutput AND $C0;

 ModulatorScalingLevel[BassDrumVoice] :=
   BassDrum[Modulator].ScalingOutput AND $C0;

 Algorithm[BassDrumVoice] := Boolean(BassDrum[Modulator].FeedBack AND $01);
 MaxVolume[BassDrumVoice] := BassDrum[Carrier].ScalingOutput AND $3f;
 MaxVolume[BassDrumVoice] := Byte(MaxVolume[BassDrumVoice] - $3F);
 MaxVolume[BassDrumVoice] := Byte(0 - MaxVolume[BassDrumVoice]);

 WriteAdlibPort(TablePModulator[BassDrumVoice] + $20,
                BassDrum[Modulator].WaveChar);
 WriteAdlibPort(TablePModulator[BassDrumVoice] + $40,
                BassDrum[Modulator].ScalingOutput);
 WriteAdlibPort(TablePModulator[BassDrumVoice] + $60,
                BassDrum[Modulator].AttackDecay);
 WriteAdlibPort(TablePModulator[BassDrumVoice] + $80,
                BassDrum[Modulator].SustainRelease);
 WriteAdlibPort( BassDrumVoice                 + $C0,
                BassDrum[Modulator].Feedback);
 WriteAdlibPort(TablePModulator[BassDrumVoice] + $E0,
                BassDrum[Modulator].SetWaveSelect);

 WriteAdlibPort(TablePModulator[BassDrumVoice] + $23,
                BassDrum[Carrier].WaveChar);
 WriteAdlibPort(TablePModulator[BassDrumVoice] + $43,
                BassDrum[Carrier].ScalingOutput);
 WriteAdlibPort(TablePModulator[BassDrumVoice] + $63,
                BassDrum[Carrier].AttackDecay);
 WriteAdlibPort(TablePModulator[BassDrumVoice] + $83,
                BassDrum[Carrier].SustainRelease);
 WriteAdlibPort(TablePModulator[BassDrumVoice] + $E3,
                BassDrum[Carrier].SetWaveSelect);

 { The other percussive voices only have one }
 CarrierScalingLevel[SnareDrumVoice] := SnareDrum.ScalingOutput   AND $C0;
 ModulatorScalingLevel[SnareDrumVoice] := SnareDrum.ScalingOutput AND $C0;

 Algorithm[SnareDrumVoice] := Boolean(SnareDrum.FeedBack AND $01);
 MaxVolume[SnareDrumVoice] := SnareDrum.ScalingOutput AND $3f;
 MaxVolume[SnareDrumVoice] := Byte(MaxVolume[SnareDrumVoice] - $3F);
 MaxVolume[SnareDrumVoice] := Byte(0 - MaxVolume[SnareDrumVoice]);

 WriteAdlibPort(TablePModulator[SnareDrumVoice] + $20, SnareDrum.WaveChar);
 WriteAdlibPort(TablePModulator[SnareDrumVoice] + $40, SnareDrum.ScalingOutput);
 WriteAdlibPort(TablePModulator[SnareDrumVoice] + $60, SnareDrum.AttackDecay);
 WriteAdlibPort(TablePModulator[SnareDrumVoice] + $80, SnareDrum.SustainRelease);
 WriteAdlibPort(SnareDrumVoice + $C0, SnareDrum.Feedback);
 WriteAdlibPort(TablePModulator[SnareDrumVoice] + $E0, SnareDrum.SetWaveSelect);

 CarrierScalingLevel[TomTomVoice] := TomTom.ScalingOutput   AND $C0;
 ModulatorScalingLevel[TomTomVoice] := TomTom.ScalingOutput AND $C0;
 Algorithm[TomTomVoice] := Boolean(TomTom.FeedBack AND $01);
 MaxVolume[TomTomVoice] := TomTom.ScalingOutput AND $3f;
 MaxVolume[TomTomVoice] := Byte(MaxVolume[TomTomVoice] - $3F);
 MaxVolume[TomTomVoice] := Byte(0 - MaxVolume[TomTomVoice]);

 WriteAdlibPort(TablePModulator[TomTomVoice] + $20, TomTom.WaveChar);
 WriteAdlibPort(TablePModulator[TomTomVoice] + $40, TomTom.ScalingOutput);
 WriteAdlibPort(TablePModulator[TomTomVoice] + $60, TomTom.AttackDecay);
 WriteAdlibPort(TablePModulator[TomTomVoice] + $80, TomTom.SustainRelease);
 WriteAdlibPort(TomTomVoice + $C0, TomTom.Feedback);
 WriteAdlibPort(TablePModulator[TomTomVoice] + $E0, TomTom.SetWaveSelect);

 CarrierScalingLevel[CymbalVoice] := Cymbal.ScalingOutput   AND $C0;
 ModulatorScalingLevel[CymbalVoice] := Cymbal.ScalingOutput AND $C0;

 Algorithm[CymbalVoice] := Boolean(Cymbal.FeedBack AND $01 );
 MaxVolume[CymbalVoice] := Cymbal.ScalingOutput    AND $3f;
 MaxVolume[CymbalVoice] := Byte(MaxVolume[CymbalVoice] - $3F);
 MaxVolume[CymbalVoice] := Byte(0 - MaxVolume[CymbalVoice]);

 WriteAdlibPort(TablePModulator[CymbalVoice] + $20, Cymbal.WaveChar);
 WriteAdlibPort(TablePModulator[CymbalVoice] + $40, Cymbal.ScalingOutput);
 WriteAdlibPort(TablePModulator[CymbalVoice] + $60, Cymbal.AttackDecay);
 WriteAdlibPort(TablePModulator[CymbalVoice] + $80, Cymbal.SustainRelease);

 WriteAdlibPort(CymbalVoice + $C0, Cymbal.Feedback);
 WriteAdlibPort(TablePModulator[CymbalVoice] + $E0, Cymbal.SetWaveSelect);

 CarrierScalingLevel[HihatVoice] := HiHat.ScalingOutput   AND $C0;
 ModulatorScalingLevel[HihatVoice] := HiHat.ScalingOutput AND $C0;

 Algorithm[HihatVoice] := Boolean(HiHat.FeedBack AND $01);
 MaxVolume[HihatVoice] := HiHat.ScalingOutput AND $3f;
 MaxVolume[HihatVoice] := Byte(MaxVolume[HihatVoice] - $3F);
 MaxVolume[HihatVoice] := Byte(0 - MaxVolume[HihatVoice]);

 WriteAdlibPort(TablePModulator[HihatVoice] + $20, Hihat.WaveChar);
 WriteAdlibPort(TablePModulator[HihatVoice] + $40, Hihat.ScalingOutput);
 WriteAdlibPort(TablePModulator[HihatVoice] + $60, Hihat.AttackDecay);
 WriteAdlibPort(TablePModulator[HihatVoice] + $80, Hihat.SustainRelease);

 WriteAdlibPort(HihatVoice + $C0, Hihat.Feedback);
 WriteAdlibPort(TablePModulator[HihatVoice] + $E0, Hihat.SetWaveSelect);
end;


procedure SetMelodicInstruments;
var
  Voice: Byte;
begin

 For Voice:=0 to MaxVoices do
   begin
     { Put the volume in the volume registers so we can thereafter change them }
     CarrierScalingLevel[Voice]   := ElectricPiano[Carrier].ScalingOutput   AND $C0;
     ModulatorScalingLevel[Voice] := ElectricPiano[Modulator].ScalingOutput AND $C0;
     Algorithm[Voice] := Boolean(ElectricPiano[Modulator].FeedBack AND $01);
     MaxVolume[Voice] := ElectricPiano[Carrier].ScalingOutput AND $3f;
     MaxVolume[Voice] := Byte(MaxVolume[Voice] - $3F);
     MaxVolume[Voice] := Byte(0 - MaxVolume[Voice]);

     WriteAdlibPort(TableModulator[Voice] + $20, ElectricPiano[Modulator].WaveChar);
     WriteAdlibPort(TableModulator[Voice] + $23, ElectricPiano[Carrier].WaveChar);

     WriteAdlibPort(TableModulator[Voice] + $40,
	   ElectricPiano[Modulator].ScalingOutput);
     WriteAdlibPort(TableModulator[Voice] + $43,
	   ElectricPiano[Carrier].ScalingOutput);

     WriteAdlibPort(TableModulator[Voice] + $60,
	   ElectricPiano[Modulator].AttackDecay);
     WriteAdlibPort(TableModulator[Voice] + $63,
	   ElectricPiano[Carrier].AttackDecay);

     WriteAdlibPort(TableModulator[Voice] + $80,
	   ElectricPiano[Modulator].SustainRelease);
     WriteAdlibPort(TableModulator[Voice] + $83,
	   ElectricPiano[Carrier].SustainRelease);

     WriteAdlibPort(TableModulator[Voice] + $E0,
	   ElectricPiano[Modulator].SetWaveSelect);
     WriteAdlibPort(TableModulator[Voice] + $E3,
	   ElectricPiano[Carrier].SetWaveSelect);

     WriteAdlibPort($C0 + Voice, ElectricPiano[Modulator].Feedback);
   end;
end;





Function CalcNote(Voice:byte; Note: Byte): Word; Assembler;
{ Calculate the note to output to A0 and B0 registers
  Taken directly from the SBlaster FM Driver
  Possible value is from 0 to 127                     }
asm
		xor     aX, ax
		xor     bX, bx
{		LES     SI, [Self]}

		mov     Bl, [Voice]
		mov     Al,Byte Ptr [Note]

		cbw

		xor     Di, Di
		add     Di,Ax
		jns     @b06c12
		sub     Di,Di

@b06c12:        and     Di,7fh
		mov     Al,Byte Ptr NoteTab[Di]
		mov     Dl,Al
		and     Dl,70h
		shr     Dl,1
		shr     Dl,1
		and     Al,0fh
		cbw
		xchg    Al,Ah
		shr     Ax,1
		shr     Ax,1
		shr     Ax,1
		shl     Bx,1
{		add     Ax,Word ptr ES:[SI].SemiToneCurrent[Bx]}
		add     Ax,Word ptr SemiToneCurrent[Bx] {***}
		jns     @b06c43
		add     Ax,0180h
		sub     Dl,04
		jns     @b06c58
		sub     Dl,Dl
		sub     Ax,Ax
		jmp     @b06c58
@b06c43:        cmp     Ax,0180h
		jb      @b06c58
		sub     Ax,0180h
		add     Dl,04
		cmp     Dl,1ch
		jnb     @b06c58
		mov     Ax,017fh
		mov     Dl,1ch
@b06c58:        shl     Ax,1
		mov     Di,Ax
		mov     Ax,Word Ptr FreqTable[Di]
		or      Ah,Dl
end;


procedure SetVolume(Voice: Byte; AVolume: Byte);
{ AVolume is a value between 0-127
  INFORMATION: From Adlib docs, if the algorithm does     support
  additive synthesis (i.e Alg = 0), the volume is modified by the
  carrier output level only.
  On the other hand, if the Alg = 1, each operator produces a
  sound directly, in that case, BOTH operators must be used to    }
{ change the output level.                                        }
var
 ValueOne: Byte;  { Modulator modification }
 ValueTwo: Byte;  { Carrier Modification   }
begin
 asm
{	Les     Si, [Self]}
	xor     ax, ax
	xor     bx, bx
	xor     cx, cx

	mov     Bl, [Voice]
	mov     Cl, [Avolume]
	or      Cl,80h
{	mov     Al,Byte ptr ES:[SI].Volume[Bx]}
	mov     Al,Byte ptr MaxVolume[Bx] {***}
	mul     Cl
	mov     Al,3fh
	sub     Al,Ah  { Change the volume level.}
        mov     cl, al

{	Mov     AH,Byte Ptr Es:[Si].CarrierScalingLevel[Bx]}
	mov     AH,Byte Ptr CarrierScalingLevel[Bx] {***}
	or      AL, AH
	mov     [ValueOne], Al
{	Mov     AH,Byte Ptr Es:[Si].ModulatorScalingLevel[Bx]}
	mov     AH,Byte Ptr ModulatorScalingLevel[Bx] {***}
	or      cl, ah
        mov     [ValueTwo], cl
 end;
  { If Melodic mode, or if the voice number is a melodic voice
    then output volume level normally.                         }
  If (Not Percussive) OR ((Voice < BassDrumVoice) AND Percussive) then
  begin
     WriteAdlibPort(TableModulator[Voice] + $43, ValueOne);
     { If the sound is produced directly by both operators }
     If Algorithm[Voice] then
	WriteAdlibPort(TableModulator[Voice] + $40, ValueTwo);
  end
  else
  begin
   { This Voice has two operators in Percussive mode, write to
     normal operator.                                          }
   If Voice = BassDrumVoice then
   begin
     WriteAdlibPort(TablePModulator[Voice] + $43, ValueOne);
   end
   else
     { These percussive voices only have one operator each, write
       the volume level directly.                                 }
     WriteAdlibPort(TablePModulator[Voice] + $40, ValueOne);
  end;
end;


procedure SemiToneup(Voice: Byte; Value: Shortint);
{ Number of Semi-tones to increase the notes by }
begin
  asm
{      Les     Di, [Self]}
      Mov     Ah, [Value]
      Mov     Al,Ah
      Cbw
      Sar     Ax,1
      Sar     Ax,1
      Xor     Bh, Bh
      Mov     Bl,[Voice]
      Shl     Bx,1
{      Mov     Word Ptr ES:[DI].SemiToneCurrent[Bx],Ax}
      Mov     Word Ptr SemiToneCurrent[Bx],Ax {***}
 end;
 { Retrigger note if it is already playing }
 If (NotePlaying[Voice]) AND (NOT Percussive) then
 begin
  Output[Voice] := CalcNote(Voice, CurrentPlayingNote[Voice]);
  WriteAdlibPort($A0 + Voice, Lo(Output[Voice]));
   { Enable key on by adding bitwise bit 5 }
  WriteAdlibPort($B0 + Voice, hi(Output[Voice]) OR $20);
 end;
end;


procedure SemiToneDown(Voice: Byte; Value: Shortint);
{ Number of Semi-tones to decrease the notes by }
begin
  asm
{   Les     Di, [Self]}
   Mov     Ah, [Value]
   Neg     Ah
   Mov     Al,Ah
   Cbw
   Sar     Ax,1
   Sar     Ax,1
   Xor     Bh, Bh
   Mov     Bl,[Voice]
   Shl     Bx,1
{      Mov     Word Ptr ES:[DI].SemiToneCurrent[Bx],Ax}
   Mov     Word Ptr SemiToneCurrent[Bx],Ax {***}
 end;
 { Retrigger note if it is already playing }
 If (NotePlaying[Voice]) AND (NOT Percussive) then
   begin
     Output[Voice] := CalcNote(Voice, CurrentPlayingNote[Voice]);
     WriteAdlibPort($A0 + Voice, Lo(Output[Voice]));
     { Enable key on by adding bitwise bit 5 }
     WriteAdlibPort($B0 + Voice, hi(Output[Voice]) OR $20);
   end;
end;

{ $BD REGISTER FUNCTIONS
  Write to the register at &HBD which controls AM Depth, VIB depth, rhythm
  (melo/perc mode) and note on/off for the percussive voices. }

{ SETS BIT 7 - AM depth }
procedure SetAM(AM: Boolean);
begin
 If AM then
   BDRegister := BDRegister OR $80
 else
   BDRegister := BDRegister AND $7F;
 WriteAdlibPort($BD, BdRegister);
end;

procedure SetVibrato(Vib: Boolean);
begin
 If Vib then
 { Enable bit 6 }
  BDRegister := BDRegister OR $40
 else
  BDRegister := BDRegister AND $Bf;
 { Clear Cport.Depth bit 6 }
 WriteAdlibPort($BD, BDRegister);
end;


{ REGISTERS $60-$75 ->  Attack Rate/ Decay Rate Change                         }
procedure AllAttackDecay(Voice: Byte; ModCar: TBit; Value: Byte);
begin
 WriteAdlibPort($60+SlotMVoice[Voice][ModCar], Value);
end;


{ AM / Vibrato / EG (Sustain) / Keyboard Scaling Rate (KSR) / Mod. multiplicator }
procedure SetWaveChar(Voice: Byte; ModCar: TBit; Value: Byte);
begin
 WriteAdlibPort($20+SlotMVoice[Voice][ModCar], Value);
end;



procedure AllScalingOutput(Voice: Byte; ModCar: TBit; Value: Byte);
begin
 WriteAdlibPort($40+ SlotMVoice[Voice][ModCar], Value);
end;


{ BYTES $C0-$C8 = Feedback/ Algorithm
  Write to the register at &HC0 which controls FEED-BACK and FM (connection).
  Applicable only to operator 0. }

procedure AllFeedback(Voice: Byte; Value: Byte);
begin
 WriteAdlibPort($C0 + Voice, Value);
end;


{ BYTES $80-95 SUSTAIN/ RELEASE RATES
  Write to the register at &H80 which controls the sustain level and
  release rate. }
procedure AllSusRelease(Voice: Byte; ModCar: TBit; Value: Byte);
begin
 WriteAdlibPort($80+SlotMVoice[Voice][ModCar], Value);
end;


{ Write to the register at &HE0 which controls the type of wave-form which
  will be used for this slot. }
procedure SetWaveSelect(Voice:Byte; ModCar: TBit; Value: Byte);
begin
  { BUGFIX -> Check for zero value first! }
  { ????????????????????????????????????? }
  If Value <> 0 then
      WriteAdlibPort($E0 + SlotMvoice[Voice][ModCar], Value);
end;

procedure AdLibDone;
var
 i: Word;
begin
   { Reset\Silence the Sound Card
     This could be replaced by a gradual scale down }
   FOR i := $01 TO $F5 do WriteAdlibPort(i, 0);
end;


begin
  AdlibInit;
end.
